/**************************************************************************

	ns

	func_code.c

	(C) Copyright 1996-2001 By Tomoaki Nakashima. All right reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#include <windows.h>

#include "script.h"
#include "script_memory.h"
#include "script_string.h"
#include "script_code.h"


/**************************************************************************
	Define
**************************************************************************/

/**************************************************************************
	Global Variables
**************************************************************************/

extern char AppDir[];


/**************************************************************************
	Local Function Prototypes
**************************************************************************/


/******************************************************************************

	_sfunc_isleadchar

	Sp1oCgڂǂ`FbN

******************************************************************************/

int SFUNC _sfunc_isleadchar(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	if(param == NULL){
		return -2;
	}

	if(param->v->Type == TYPE_STRING && IsLeadChar(*param->v->u.Value) == TRUE){
		ret->v->u.iValue = 1;
	}else{
		ret->v->u.iValue = 0;
	}
	ret->v->Type = TYPE_INTEGER;
	return 0;
}


/******************************************************************************

	_sfunc_getcodetype

	R[h̎ނ擾

******************************************************************************/

int SFUNC _sfunc_getcodetype(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	char *p;
	int rc;
	BOOL eucflag = FALSE;

	if(param == NULL){
		return -2;
	}

	if(param->v->Type == TYPE_STRING){
		p = param->v->u.Value;
		ret->v->u.iValue = 0;
		while(*p != '\0'){
			rc = GetKanjiType(p);
			switch(rc)
			{
			case 0:		//ASCII
				p++;
				break;

			case 9:		//EUCSJISpJi
				eucflag = TRUE;
				p += 2;
				break;

			case 2:		//SJIS
				ret->v->u.iValue = 1;
				break;

			case 4:		//EUCpJi
			case 8:		//EUC
				ret->v->u.iValue = 3;
				break;

			case 16:	//VJIS
			case 32:	//JIS
				ret->v->u.iValue = 2;
				break;

			default:
				p += 2;
				break;
			}
			if(ret->v->u.iValue != 0){
				break;
			}
		}
		if(eucflag == TRUE && ret->v->u.iValue == 0){
			ret->v->u.iValue = 3;
		}
	}else{
		ret->v->u.iValue = 0;
	}
	ret->v->Type = TYPE_INTEGER;
	return 0;
}


/******************************************************************************

	_sfunc_sjistojis

	SJISJISɕϊ

******************************************************************************/

int SFUNC _sfunc_sjistojis(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	char *str;

	if(param == NULL){
		return -2;
	}

	str = GetValueString(param->v);

	ret->v->u.Value = mem_alloc(sizeof(char) * (tstrlen(str) * 4 + 1));
	if(ret->v->u.Value == NULL){
		tstrcpy(ErrStr, "SjisToJis: ̊mۂɎs܂B");
		mem_free(&str);
		return -1;
	}
	SjisToJis(str, ret->v->u.Value);
	ret->v->Type = TYPE_STRING;
	mem_free(&str);
	return 0;
}


/******************************************************************************

	_sfunc_jistosjis

	JISSJISɕϊ

******************************************************************************/

int SFUNC _sfunc_jistosjis(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	char *str;

	if(param == NULL){
		return -2;
	}

	str = GetValueString(param->v);

	ret->v->u.Value = mem_alloc(sizeof(char) * (tstrlen(str) + 1));
	if(ret->v->u.Value == NULL){
		tstrcpy(ErrStr, "JisToSjis: ̊mۂɎs܂B");
		mem_free(&str);
		return -1;
	}
	JisToSjis(str, ret->v->u.Value);
	ret->v->Type = TYPE_STRING;
	mem_free(&str);
	return 0;
}


/******************************************************************************

	_sfunc_sjistoeuc

	SJISEUCɕϊ

******************************************************************************/

int SFUNC _sfunc_sjistoeuc(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	char *str;

	if(param == NULL){
		return -2;
	}

	str = GetValueString(param->v);

	ret->v->u.Value = mem_alloc(sizeof(char) * (tstrlen(str) + 1));
	if(ret->v->u.Value == NULL){
		tstrcpy(ErrStr, "EucToSjis: ̊mۂɎs܂B");
		mem_free(&str);
		return -1;
	}
	SjisToEuc(str, ret->v->u.Value);
	ret->v->Type = TYPE_STRING;
	mem_free(&str);
	return 0;
}



/******************************************************************************

	_sfunc_euctosjis

	EUCSJISɕϊ

******************************************************************************/

int SFUNC _sfunc_euctosjis(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	char *str;

	if(param == NULL){
		return -2;
	}

	str = GetValueString(param->v);

	ret->v->u.Value = mem_alloc(sizeof(char) * (tstrlen(str) + 1));
	if(ret->v->u.Value == NULL){
		tstrcpy(ErrStr, "EucToSjis: ̊mۂɎs܂B");
		mem_free(&str);
		return -1;
	}
	EucToSjis(str, ret->v->u.Value);
	ret->v->Type = TYPE_STRING;
	mem_free(&str);
	return 0;
}


/******************************************************************************

	_sfunc_hashtosjis

	nbVɓSJISɕϊ

******************************************************************************/

int SFUNC _sfunc_hashtosjis(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	VALUEINFO *vi;
	char *cbuf, *cret, *str;
	int hlen;

	if(param == NULL){
		return -2;
	}

	vi = param;
	hlen = Hash2Byte(vi, &cbuf);
	str = mem_alloc(hlen + 1);
	CopyMemory(str, cbuf, hlen);
	mem_free(&cbuf);
	*(str + hlen) = '\0';

	cret = mem_alloc(hlen + 1);
	ConvStrCode(str, cret);
	mem_free(&str);

	ret->v->u.Value = cret;
	ret->v->Type = TYPE_STRING;
	return 0;
}


/******************************************************************************

	_sfunc_base64decode

	BASE64̃fR[h

******************************************************************************/

int SFUNC _sfunc_base64decode(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	char *str;

	if(param == NULL){
		return -2;
	}

	str = GetValueString(param->v);

	ret->v->u.Value = mem_alloc(tstrlen(str));
	if(ret->v->u.Value == NULL){
		tstrcpy(ErrStr, "Base64Decode: ̊mۂɎs܂B");
		mem_free(&str);
		return -1;
	}
	dBase(str, ret->v->u.Value);
	ret->v->Type = TYPE_STRING;
	mem_free(&str);
	return 0;
}


/******************************************************************************

	_sfunc_base64decodehash

	BASE64̃fR[h

******************************************************************************/

int SFUNC _sfunc_base64decodehash(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	VALUEINFO *vi;
	char *r;
	char *cret, *rf;

	if(param == NULL){
		return -2;
	}

	//ϐ
	r = GetValueString(param->v);
	if((param = param->next) == NULL){
		mem_free(&r);
		return -2;
	}

	//nbV
	vi = param->v->vi;

	cret = mem_alloc(tstrlen(r));
	if(cret == NULL){
		tstrcpy(ErrStr, "Base64Decode: ̊mۂɎs܂B");
		mem_free(&r);
		return -1;
	}
	rf = dBase(r, cret);
	Byte2Hash(ei, vi, cret, rf - cret);
	mem_free(&cret);
	mem_free(&r);
	return 0;
}


/******************************************************************************

	_sfunc_base64encode

	BASE64ɃGR[h

******************************************************************************/

int SFUNC _sfunc_base64encode(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	char *str;

	if(param == NULL){
		return -2;
	}

	str = GetValueString(param->v);

	ret->v->u.Value = mem_alloc(tstrlen(str) * 2 + 4);
	if(ret->v->u.Value == NULL){
		tstrcpy(ErrStr, "Base64Encode: ̊mۂɎs܂B");
		mem_free(&str);
		return -1;
	}
	eBase(str, ret->v->u.Value, 0);
	ret->v->Type = TYPE_STRING;
	mem_free(&str);
	return 0;
}


/******************************************************************************

	_sfunc_base64encodehash

	BASE64ɃGR[h

******************************************************************************/

int SFUNC _sfunc_base64encodehash(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	VALUEINFO *vi;
	char *cbuf, *cret;
	int hlen;

	if(param == NULL){
		return -2;
	}

	vi = param;
	hlen = Hash2Byte(vi, &cbuf);

	cret = mem_alloc(hlen * 2 + 4);
	eBase(cbuf, cret, hlen);
	mem_free(&cbuf);

	ret->v->u.Value = cret;
	ret->v->Type = TYPE_STRING;
	return 0;
}
/* End of source */
