/**************************************************************************

	ns

	func_hash.c

	(C) Copyright 1996-2001 By Tomoaki Nakashima. All right reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#include <windows.h>

#include "script.h"
#include "script_memory.h"
#include "script_string.h"


/**************************************************************************
	Define
**************************************************************************/

typedef int (__cdecl SORTFUNC)(const void *, const void *);


/**************************************************************************
	Global Variables
**************************************************************************/

/**************************************************************************
	Local Function Prototypes
**************************************************************************/

/******************************************************************************

	_sfunc_gethashcount

	nbV̍ڐ擾

******************************************************************************/

int SFUNC _sfunc_gethashcount(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	VALUEINFO *vi;
	int i = 0;

	if(param == NULL){
		return -2;
	}

	//ڐ擾
	for(vi = param->vi; vi != NULL; vi = vi->next, i++);

	ret->v->u.iValue = i;
	ret->v->Type = TYPE_INTEGER;
	return 0;
}


/******************************************************************************

	_sfunc_sethashcount

	nbV̗vf̕ύX

******************************************************************************/

int SFUNC _sfunc_sethashcount(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	VALUEINFO *pvi, *vi;
	VALUEINFO *kvi;
	int i = 0, len;

	if(param == NULL){
		return -2;
	}

	pvi = vi = param->v->vi;
	if((param = param->next) == NULL){
		return -2;
	}
	len = GetValueInt(param->v);

	if(len <= 0){
		FreeValueList(vi->vi);
		pvi->vi = NULL;
		return 0;
	}
	if(vi->vi == NULL){
		//VKǉ
		vi = vi->vi = AllocValue();
		if(vi != NULL){
			SetValue(ei, vi->v, pvi->v);
			vi->v->Global = pvi->v->Global;
		}
		i++;
	}else{
		//
		for(vi = vi->vi; vi != NULL; vi = vi->next, i++){
			if(i == len){
				//
				FreeValueList(vi);
				kvi->next = NULL;
				return 0;
			}
			kvi = vi;
		}
		vi = kvi;
	}
	//sǉ
	for(; i < len; i++){
		vi = vi->next = AllocValue();
		if(vi != NULL){
			SetValue(ei, vi->v, pvi->v);
			vi->v->Global = pvi->v->Global;
		}
	}
	return 0;
}


/******************************************************************************

	_sfunc_gethashkey

	nbV̎wʒũL[擾

******************************************************************************/

int SFUNC _sfunc_gethashkey(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	VALUEINFO *vi;
	int i = 0, j;

	if(param == NULL){
		return -2;
	}

	vi = param->vi;
	if((param = param->next) == NULL){
		return -2;
	}
	j = GetValueInt(param->v);

	for(; vi != NULL && i != j; vi = vi->next, i++);

	if(vi != NULL && vi->Name != NULL){
		ret->v->u.Value = alloc_copy(vi->Name);
	}else{
		ret->v->u.Value = alloc_copy("");
	}
	ret->v->Type = TYPE_STRING;
	return 0;
}


/******************************************************************************

	_sfunc_sethashkey

	nbV̎wʒũL[ݒ

******************************************************************************/

int SFUNC _sfunc_sethashkey(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	VALUEINFO *vi;
	char *r;

	if(param == NULL){
		return -2;
	}

	vi = param;
	if((param = param->next) == NULL){
		return -2;
	}
	vi = GetHashValue(ei, vi, param->v);
	if((param = param->next) == NULL){
		return -2;
	}
	r = GetValueString(param->v);

	if(vi != NULL){
		mem_free(&vi->Name);
		vi->Name = r;
		vi->name_hash = str2hash(vi->Name);
	}else{
		mem_free(&r);
	}
	return 0;
}


/******************************************************************************

	_sfunc_ishashkey

	nbVɃL[݂邩`FbN

******************************************************************************/

int SFUNC _sfunc_ishashkey(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	VALUEINFO *vi;
	char *r;
	int name_hash;
	int i = 0;

	if(param == NULL){
		return -2;
	}

	//ϐ擾
	vi = param->vi;
	if((param = param->next) == NULL){
		return -2;
	}
	r = GetValueString(param->v);
	name_hash = str2hash(r);

	for(; vi != NULL; vi = vi->next, i++){
		if(vi->Name != NULL &&
			name_hash == vi->name_hash && tstrcmp(r, vi->Name) == 0){
			break;
		}
	}
	ret->v->u.iValue = (vi != NULL) ? i : -1;
	ret->v->Type = TYPE_INTEGER;
	mem_free(&r);
	return 0;
}


/******************************************************************************

	_sfunc_hashinsert

	nbVڂ̑}

******************************************************************************/

int SFUNC _sfunc_hashinsert(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	VALUEINFO *vi, *wkvi = NULL, *Tovi, *pvi;
	char *r;
	int name_hash;
	int i, j;

	if(param == NULL){
		return -2;
	}

	pvi = param->v->vi;
	vi = param->vi;
	if((param = param->next) == NULL){
		return -2;
	}
	if(param->v->Type == TYPE_INTEGER){
		//CfbNX
		for(i = 0, j = param->v->u.iValue; vi != NULL && i < j; vi = vi->next, i++){
			wkvi = vi;
		}
	}else{
		//L[
		r = GetValueString(param->v);
		name_hash = str2hash(r);

		for(; vi != NULL; vi = vi->next){
			if(vi->Name != NULL &&
				name_hash == vi->name_hash && tstrcmp(r, vi->Name) == 0){
				break;
			}
			wkvi = vi;
		}
		mem_free(&r);
	}
	if((param = param->next) == NULL){
		return -2;
	}

	Tovi = AllocValue();
	if(param->Name != NULL){
		Tovi->Name = alloc_copy(param->Name);
		Tovi->name_hash = param->name_hash;
	}
	SetValue(ei, Tovi->v, param->v);
	Tovi->vi = CopyValueList(param->vi);
	Tovi->next = vi;
	if(wkvi != NULL){
		wkvi->next = Tovi;
	}else{
		pvi->vi = Tovi;
	}
	return 0;
}


/******************************************************************************

	_sfunc_hashdelete

	nbVڂ̍폜

******************************************************************************/

int SFUNC _sfunc_hashdelete(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	VALUEINFO *vi, *pvi, *wkvi = NULL;
	char *r;
	int name_hash;
	int i, j;

	if(param == NULL){
		return -2;
	}

	pvi = param->v->vi;
	vi = param->vi;
	if((param = param->next) == NULL){
		return -2;
	}
	if(param->v->Type == TYPE_INTEGER){
		//CfbNX
		for(i = 0, j = param->v->u.iValue; vi != NULL && i < j; vi = vi->next, i++){
			wkvi = vi;
		}
	}else{
		//L[
		r = GetValueString(param->v);
		name_hash = str2hash(r);

		for(; vi != NULL; vi = vi->next){
			if(vi->Name != NULL &&
				name_hash == vi->name_hash && tstrcmp(r, vi->Name) == 0){
				break;
			}
			wkvi = vi;
		}
		mem_free(&r);
	}
	if(wkvi == NULL && vi != NULL){
		pvi->vi = vi->next;
		FreeValue(vi);
	}else if(wkvi != NULL && vi != NULL){
		wkvi->next = vi->next;
		FreeValue(vi);
	}
	return 0;
}


/******************************************************************************

	_sfunc_hashfind

	nbVě

******************************************************************************/

int SFUNC _sfunc_hashfind(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	VALUEINFO *vi;
	int i, j = -1;

	if(param == NULL){
		return -2;
	}

	vi = param->vi;
	if((param = param->next) == NULL){
		return -2;
	}
	for(i = 0; vi != NULL; vi = vi->next, i++){
		if(vi->v->Type != param->v->Type){
			continue;
		}
		if(vi->v->Type == TYPE_INTEGER){
			if(vi->v->u.iValue == param->v->u.iValue){
				j = i;
				break;
			}
		}else{
			if(tstrcmp(vi->v->u.Value, param->v->u.Value) == 0){
				j = i;
				break;
			}
		}
	}
	ret->v->u.iValue = j;
	ret->v->Type = TYPE_INTEGER;
	return 0;
}


/******************************************************************************

	kcmp_

	\[gp̔r֐

******************************************************************************/

static int __cdecl kcmp_up(const void *e1, const void *e2)
{
	char *str1 = (*(VALUEINFO **)e1)->Name, *str2 = (*(VALUEINFO **)e1)->Name;
	if(str1 == NULL) str1 = "";
	if(str2 == NULL) str2 = "";
	return tstrcmp(str1, str2);
}
static int __cdecl kcmp_down(const void *e1, const void *e2)
{
	char *str1 = (*(VALUEINFO **)e1)->Name, *str2 = (*(VALUEINFO **)e1)->Name;
	if(str1 == NULL) str1 = "";
	if(str2 == NULL) str2 = "";
	return tstrcmp(str2, str1);
}
static int __cdecl kcmp_up_i(const void *e1, const void *e2)
{
	char *str1 = (*(VALUEINFO **)e1)->Name, *str2 = (*(VALUEINFO **)e1)->Name;
	if(str1 == NULL) str1 = "";
	if(str2 == NULL) str2 = "";
	return str_cmp_i(str1, str2);
}
static int __cdecl kcmp_down_i(const void *e1, const void *e2)
{
	char *str1 = (*(VALUEINFO **)e1)->Name, *str2 = (*(VALUEINFO **)e1)->Name;
	if(str1 == NULL) str1 = "";
	if(str2 == NULL) str2 = "";
	return str_cmp_i(str2, str1);
}


/******************************************************************************

	_sfunc_hashkeysort

	nbVL[̃\[g

******************************************************************************/

int SFUNC _sfunc_hashkeysort(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	VALUEINFO *vi, *pvi, *wkvi;
	VALUEINFO **svi;
	SORTFUNC *sort_func;
	int i, j;
	int order = 0;
	int icase = 0;

	if(param == NULL){
		return -2;
	}

	pvi = param->v->vi;
	vi = param->vi;
	if((param = param->next) != NULL){
		order = GetValueInt(param->v);
		if((param = param->next) != NULL){
			icase = GetValueInt(param->v);
		}
	}

	//Azz񐔂̃JEg
	for(wkvi = vi, i = 0; wkvi != NULL; wkvi = wkvi->next, i++);

	//m
	svi = (VALUEINFO **)mem_alloc(sizeof(VALUEINFO *) * i);
	if(svi == NULL){
		return -1;
	}
	//ϐXgzɃRs[
	for(wkvi = vi, i = 0; wkvi != NULL; wkvi = wkvi->next, i++){
		*(svi + i) = wkvi;
	}

	//sort
	if(order == 0 && icase == 0){
		sort_func = kcmp_up;
	}else if(order != 0 && icase == 0){
		sort_func = kcmp_down;
	}else if(order == 0 && icase != 0){
		sort_func = kcmp_up_i;
	}else{
		sort_func = kcmp_down_i;
	}
	qsort(svi, i, sizeof(VALUEINFO *), sort_func);

	//ϐXg̍č\z
	for(j = 0; j < i - 1; j++){
		(*(svi + j))->next = *(svi + j + 1);
	}
	(*(svi + j))->next = NULL;

	pvi->vi = *(svi + 0);
	mem_free((void *)&svi);
	return 0;
}


/******************************************************************************

	cmp_

	\[gp̔r֐

******************************************************************************/

static int __cdecl cmp_up(const void *e1, const void *e2)
{
	int ret;

	if((*(VALUEINFO **)e1)->v->Type == TYPE_INTEGER && (*(VALUEINFO **)e2)->v->Type == TYPE_INTEGER){
		ret = (*(VALUEINFO **)e1)->v->u.iValue - (*(VALUEINFO **)e2)->v->u.iValue;
	}else{
		char *str1, *str2;
		str1 = GetValueString((*(VALUEINFO **)e1)->v);
		str2 = GetValueString((*(VALUEINFO **)e2)->v);
		ret = tstrcmp(str1, str2);
	}
	return ret;
}
static int __cdecl cmp_down(const void *e1, const void *e2)
{
	int ret;

	if((*(VALUEINFO **)e1)->v->Type == TYPE_INTEGER && (*(VALUEINFO **)e2)->v->Type == TYPE_INTEGER){
		ret = (*(VALUEINFO **)e2)->v->u.iValue - (*(VALUEINFO **)e1)->v->u.iValue;
	}else{
		char *str1, *str2;
		str1 = GetValueString((*(VALUEINFO **)e1)->v);
		str2 = GetValueString((*(VALUEINFO **)e2)->v);
		ret = tstrcmp(str2, str1);
	}
	return ret;
}
static int __cdecl cmp_up_i(const void *e1, const void *e2)
{
	int ret;

	if((*(VALUEINFO **)e1)->v->Type == TYPE_INTEGER && (*(VALUEINFO **)e2)->v->Type == TYPE_INTEGER){
		ret = (*(VALUEINFO **)e1)->v->u.iValue - (*(VALUEINFO **)e2)->v->u.iValue;
	}else{
		char *str1, *str2;
		str1 = GetValueString((*(VALUEINFO **)e1)->v);
		str2 = GetValueString((*(VALUEINFO **)e2)->v);
		ret = str_cmp_i(str1, str2);
	}
	return ret;
}
static int __cdecl cmp_down_i(const void *e1, const void *e2)
{
	int ret;

	if((*(VALUEINFO **)e1)->v->Type == TYPE_INTEGER && (*(VALUEINFO **)e2)->v->Type == TYPE_INTEGER){
		ret = (*(VALUEINFO **)e2)->v->u.iValue - (*(VALUEINFO **)e1)->v->u.iValue;
	}else{
		char *str1, *str2;
		str1 = GetValueString((*(VALUEINFO **)e1)->v);
		str2 = GetValueString((*(VALUEINFO **)e2)->v);
		ret = str_cmp_i(str2, str1);
	}
	return ret;
}


/******************************************************************************

	_sfunc_hashsort

	nbVẽ\[g

******************************************************************************/

int SFUNC _sfunc_hashsort(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	VALUEINFO *vi, *pvi, *wkvi;
	VALUEINFO **svi;
	SORTFUNC *sort_func;
	int i, j;
	int order = 0;
	int icase = 0;

	if(param == NULL){
		return -2;
	}

	pvi = param->v->vi;
	vi = param->vi;
	if((param = param->next) != NULL){
		order = GetValueInt(param->v);
		if((param = param->next) != NULL){
			icase = GetValueInt(param->v);
		}
	}

	//Azz񐔂̃JEg
	for(wkvi = vi, i = 0; wkvi != NULL; wkvi = wkvi->next, i++);

	//m
	svi = (VALUEINFO **)mem_alloc(sizeof(VALUEINFO *) * i);
	if(svi == NULL){
		return -1;
	}
	//ϐXgzɃRs[
	for(wkvi = vi, i = 0; wkvi != NULL; wkvi = wkvi->next, i++){
		*(svi + i) = wkvi;
	}

	//sort
	if(order == 0 && icase == 0){
		sort_func = cmp_up;
	}else if(order != 0 && icase == 0){
		sort_func = cmp_down;
	}else if(order == 0 && icase != 0){
		sort_func = cmp_up_i;
	}else{
		sort_func = cmp_down_i;
	}
	qsort(svi, i, sizeof(VALUEINFO *), sort_func);

	//ϐXg̍č\z
	for(j = 0; j < i - 1; j++){
		(*(svi + j))->next = *(svi + j + 1);
	}
	(*(svi + j))->next = NULL;

	pvi->vi = *(svi + 0);
	mem_free((void *)&svi);
	return 0;
}


/******************************************************************************

	_sfunc_hashcopy

	nbṼRs[

******************************************************************************/

int SFUNC _sfunc_hashcopy(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	VALUEINFO *Tovi, *Fromvi;
	int FromPoint;
	int len;
	int i;

	if(param == NULL){
		return -2;
	}

	ret->Hash = TRUE;

	//]ϐ
	Fromvi = param->vi;
	if((param = param->next) == NULL){
		FromPoint = 0;
		len = -1;
	}else{
		//]ʒu
		FromPoint = GetValueInt(param->v);
		if(FromPoint < 0){
			return 0;
		}
		if((param = param->next) == NULL){
			len = -1;
		}else{
			//
			len = GetValueInt(param->v);
		}
	}

	//]ʒüړ
	for(i = 0; Fromvi != NULL && i != FromPoint; Fromvi = Fromvi->next, i++);
	if(Fromvi == NULL){
		return 0;
	}

	//]̊m
	Tovi = ret->vi = AllocValue();
	if(Fromvi->Name != NULL){
		Tovi->Name = alloc_copy(Fromvi->Name);
		Tovi->name_hash = Fromvi->name_hash;
	}
	SetValue(ei, Tovi->v, Fromvi->v);
	Fromvi = Fromvi->next;

	//Rs[
	for(i = 1; Fromvi != NULL && (len < 0 || i < len); Fromvi = Fromvi->next, i++){
		Tovi = Tovi->next = AllocValue();
		if(Fromvi->Name != NULL){
			Tovi->Name = alloc_copy(Fromvi->Name);
			Tovi->name_hash = Fromvi->name_hash;
		}
		SetValue(ei, Tovi->v, Fromvi->v);
		Tovi->vi = CopyValueList(Fromvi->vi);
	}
	return 0;
}


/******************************************************************************

	cpval

	AzzRs[
	̃L[݂ꍇ͏㏑s

******************************************************************************/

static void cpval(EXECINFO *ei, VALUEINFO *ret, VALUEINFO *Fromvi)
{
	VALUEINFO *vi, *wkvi, *Tovi, *avi;

	if(Fromvi == NULL){
		return;
	}

	//]̊m
	if(ret->vi == NULL){
		Tovi = ret->vi = AllocValue();
		if(Fromvi->Name != NULL){
			Tovi->Name = alloc_copy(Fromvi->Name);
			Tovi->name_hash = Fromvi->name_hash;
		}
		SetValue(ei, Tovi->v, Fromvi->v);
		Fromvi = Fromvi->next;
	}else{
		for(Tovi = ret->vi; Tovi->next != NULL; Tovi = Tovi->next);
	}

	//Rs[
	for(; Fromvi != NULL; Fromvi = Fromvi->next){
		avi = AllocValue();
		if(Fromvi->Name != NULL){
			avi->Name = alloc_copy(Fromvi->Name);
			avi->name_hash = Fromvi->name_hash;
		}
		SetValue(ei, avi->v, Fromvi->v);
		avi->vi = CopyValueList(Fromvi->vi);

		vi = NULL;
		wkvi = NULL;
		if(avi->Name != NULL){
			for(vi = ret->vi; vi != NULL; vi = vi->next){
				if(vi->Name != NULL &&
					avi->name_hash == vi->name_hash && tstrcmp(avi->Name, vi->Name) == 0){
					break;
				}
				wkvi = vi;
			}
		}
		if(vi != NULL){
			avi->next = vi->next;
			if(wkvi == NULL){
				ret->vi = avi;
			}else{
				wkvi->next = avi;
			}
			FreeValue(vi);
		}else{
			Tovi = Tovi->next = avi;
		}
	}
}


/******************************************************************************

	_sfunc_hashmerge

	nbVڂ̃}[W

******************************************************************************/

int SFUNC _sfunc_hashmerge(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	if(param == NULL){
		return -2;
	}

	for(; param != NULL; param = param->next){
		cpval(ei, ret, param->vi);
	}

	ret->Hash = TRUE;
	return 0;
}


/******************************************************************************

	_sfunc_hashtostring

	nbV𕶎ɕϊ

******************************************************************************/

int SFUNC _sfunc_hashtostring(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	VALUEINFO *vi;
	char *cBuf;
	char *str;
	int hlen;

	if(param == NULL){
		return -2;
	}

	//nbV
	vi = param;
	if(vi == NULL){
		return 0;
	}
	hlen = Hash2Byte(vi, &cBuf);
	str = mem_alloc(hlen + 1);
	CopyMemory(str, cBuf, hlen);
	mem_free(&cBuf);
	*(str + hlen) = '\0';

	ret->v->u.Value = str;
	ret->v->Type = TYPE_STRING;
	return 0;
}


/******************************************************************************

	_sfunc_stringtohash

	nbVɓWJ

******************************************************************************/

int SFUNC _sfunc_stringtohash(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	char *r;

	if(param == NULL){
		return -2;
	}

	//
	r = GetValueString(param->v);

	Byte2Hash(ei, ret, r, tstrlen(r));
	ret->Hash = TRUE;
	mem_free(&r);
	return 0;
}
/* End of source */
