/**************************************************************************

	ns

	func_io.c

	(C) Copyright 1996-2001 By Tomoaki Nakashima. All right reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#include <windows.h>
#include <tchar.h>

#include "script.h"
#include "script_memory.h"
#include "script_string.h"


/**************************************************************************
	Define
**************************************************************************/

/**************************************************************************
	Global Variables
**************************************************************************/

/**************************************************************************
	Local Function Prototypes
**************************************************************************/


/******************************************************************************

	_sfunc_puts

	Wo͂ɕ

******************************************************************************/

int SFUNC _sfunc_puts(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	HANDLE ih;
	TCHAR *str;
	int size;

	if(param == NULL){
		return -2;
	}

	str = TGetValueString(param->v);

	ih = GetStdHandle(STD_OUTPUT_HANDLE);
	//Wo͂ɕo
	WriteConsole(ih, str, lstrlen(str), &size, NULL);

	mem_free(&str);
	return 0;
}


/******************************************************************************

	_sfunc_gets

	W͂當ǂݎ

******************************************************************************/

int SFUNC _sfunc_gets(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	HANDLE ih;
	TCHAR *p;
	char *cp;
	int len;
	int mode, rmode;
	int size;

	if(param == NULL){
		return -2;
	}

	len = GetValueInt(param->v);

	ih = GetStdHandle(STD_INPUT_HANDLE);
	//Wo͂̃[h擾
	GetConsoleMode(ih, &mode);
	rmode = mode;
	//s̓[hɐݒ
	mode |= ENABLE_LINE_INPUT;
	SetConsoleMode(ih, mode);
	p = mem_alloc(sizeof(TCHAR) * len + 2);
	//W͂當ǂݎ
	ReadConsole(ih, p, len + 1, &size, NULL);
	SetConsoleMode(ih, rmode);

#ifdef UNICODE
	ret->v->u.Value = tchar2char(p);
	mem_free(&p);
#else
	ret->v->u.Value = p;
#endif

	for(cp = ret->v->u.Value; *cp != '\0' && *cp != '\r' && *cp != '\n'; cp++);
	*cp = '\0';

	ret->v->Type = TYPE_STRING;
	return 0;
}


/******************************************************************************

	_sfunc_getchar

	W͂當ǂݎ

******************************************************************************/

int SFUNC _sfunc_getchar(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	HANDLE ih;
	TCHAR buf[4];
	TCHAR *p;
	int mode, rmode;
	int size;

	ih = GetStdHandle(STD_INPUT_HANDLE);
	//Wo͂̃[h擾
	GetConsoleMode(ih, &mode);
	rmode = mode;
	//̓[hɐݒ
	mode &= ~ENABLE_LINE_INPUT;
	mode &= ~ENABLE_ECHO_INPUT;

	SetConsoleMode(ih, mode);
	//W͂當ǂݎ
	ReadConsole(ih, buf, 1, &size, NULL);
	SetConsoleMode(ih, rmode);

	if(*buf == TEXT('\n')){
		*buf = TEXT('\0');
	}else if(*buf == TEXT('\r')){
		*buf = TEXT('\n');
	}
#ifdef UNICODE
	p = mem_alloc(sizeof(TCHAR) * 2);
	*p = *buf;
	*(p + 1) = '\0';
#else
	if(IsDBCSLeadByte(*buf) == TRUE && *(buf + 1) != '\0'){
		//2oCgR[h
		p = mem_alloc(sizeof(char) * 3);
		*p = *buf;
		*(p + 1) = *(buf + 1);
		*(p + 2) = '\0';
	}else{
		p = mem_alloc(sizeof(char) * 2);
		*p = *buf;
		*(p + 1) = '\0';
	}
#endif
	if(rmode & ENABLE_ECHO_INPUT){
		//echo
		ih = GetStdHandle(STD_OUTPUT_HANDLE);
		WriteConsole(ih, p, lstrlen(p), &size, NULL);
	}

#ifdef UNICODE
	ret->v->u.Value = tchar2char(p);
#else
	ret->v->u.Value = p;
#endif
	ret->v->Type = TYPE_STRING;
	return 0;
}


/******************************************************************************

	_sfunc_getecho

	W͂ECHOݒ

******************************************************************************/

int SFUNC _sfunc_setechomode(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	HANDLE ih;
	int f;
	int mode;

	if(param == NULL){
		return -2;
	}

	f = GetValueInt(param->v);

	ih = GetStdHandle(STD_INPUT_HANDLE);
	GetConsoleMode(ih, &mode);
	if(f == 0){
		mode &= ~ENABLE_ECHO_INPUT;
	}else{
		mode |= ENABLE_ECHO_INPUT;
	}
	SetConsoleMode(ih, mode);
	return 0;
}
/* End of source */
