/**************************************************************************

	ns

	func_sock.c

	(C) Copyright 1996-2001 By Tomoaki Nakashima. All right reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#include <windows.h>
#include <winsock.h>

#include "script.h"
#include "script_memory.h"
#include "script_string.h"


/**************************************************************************
	Define
**************************************************************************/

#define TIMEOUT			1		/* ^CAEgb */
#define TIMEOUTCNT		60		/* ^CAEgb */


/**************************************************************************
	Global Variables
**************************************************************************/

/**************************************************************************
	Local Function Prototypes
**************************************************************************/


/******************************************************************************

	_sfunc_gethostbyname

	zXgIPAhX擾

******************************************************************************/

int SFUNC _sfunc_gethostname(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	char MyHostName[BUF_SIZE];

	gethostname(MyHostName, BUF_SIZE - 1);
	ret->v->u.Value = alloc_copy(MyHostName);
	ret->v->Type = TYPE_STRING;
	return 0;
}


/******************************************************************************

	_sfunc_gethostbyname

	zXgIPAhX擾

******************************************************************************/

int SFUNC _sfunc_gethostbyname(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	unsigned long serveraddr;
	struct hostent *serverhostent;
	char *str;

	if(param == NULL){
		return -2;
	}
	str = GetValueString(param->v);

	serveraddr = inet_addr((char*)str);
	if(serveraddr == -1) {
		/* T[o(svName)T[ȍ擾܂ */
		ScriptWait();
		serverhostent = gethostbyname(str);
		ScriptUnWait();
		if(serverhostent == NULL) {
			serveraddr = -1;
		}else{
			/* T[ȍ񂩂IPAhXserveraddrɃRs[܂ */
			serveraddr = ntohl(*((unsigned long *)((serverhostent->h_addr_list)[0])));
		}
	}else{
		serveraddr = ntohl(serveraddr);
	}
	mem_free(&str);
	ret->v->u.iValue = serveraddr;
	ret->v->Type = TYPE_INTEGER;
	return 0;
}


/******************************************************************************

	_sfunc_getsockport

	\Pbg̃|[gԍ擾

******************************************************************************/

int SFUNC _sfunc_getsockport(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
    struct sockaddr_in socinfo;
	SOCKET soc;
	int len;

	if(param == NULL){
		return -2;
	}

	//\Pbg
	soc = (SOCKET)GetValueInt(param->v);

	len = sizeof(socinfo);
	if(getsockname(soc, (struct sockaddr *)&socinfo, &len) < 0){
		ret->v->u.iValue = -1;
	}else{
		ret->v->u.iValue = ntohs(socinfo.sin_port);
	}
	ret->v->Type = TYPE_INTEGER;
	return 0;
}


/******************************************************************************

	_sfunc_socket

	\Pbg쐬

******************************************************************************/

int SFUNC _sfunc_socket(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	SOCKET soc;
	int af = AF_INET;		//2
	int type = SOCK_STREAM;	//1
	int protocol = 0;

	if(param != NULL){
		af = GetValueInt(param->v);
		if((param = param->next) != NULL){
			type = GetValueInt(param->v);
			if((param = param->next) != NULL){
				protocol = GetValueInt(param->v);
			}
		}
	}

	soc = socket(af, type, protocol);
	if(soc == INVALID_SOCKET){
		soc = -1;
	}

	ret->v->u.iValue = soc;
	ret->v->Type = TYPE_INTEGER;
	return 0;
}


/******************************************************************************

	_sfunc_closesocket

	ؒf

******************************************************************************/

int SFUNC _sfunc_closesocket(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	SOCKET soc;

	if(param == NULL){
		return -2;
	}

	//\Pbg
	soc = (SOCKET)GetValueInt(param->v);

	shutdown(soc, 2);
	closesocket(soc);
	return 0;
}


/******************************************************************************

	_sfunc_connect

	ڑ

******************************************************************************/

int SFUNC _sfunc_connect(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	SOCKET soc;
	struct sockaddr_in serversockaddr;
	unsigned long serveraddr;
	unsigned short Port;

	if(param == NULL){
		return -2;
	}

	//\Pbg
	soc = (SOCKET)GetValueInt(param->v);
	if((param = param->next) == NULL){
		return -2;
	}

	//AhX
	serveraddr = (unsigned long)GetValueInt(param->v);
	if((param = param->next) == NULL){
		return -2;
	}

	//|[g
	Port = (unsigned short)GetValueInt(param->v);

	serversockaddr.sin_family = AF_INET;
	serversockaddr.sin_addr.s_addr = htonl(serveraddr);
	serversockaddr.sin_port = htons(Port);
	ZeroMemory(serversockaddr.sin_zero, sizeof(serversockaddr.sin_zero));

	if(connect(soc, (struct sockaddr *)&serversockaddr, sizeof(serversockaddr)) == SOCKET_ERROR){
		ret->v->u.iValue = -1;
	}else{
		ret->v->u.iValue = 0;
	}
	ret->v->Type = TYPE_INTEGER;
	return 0;
}


/******************************************************************************

	_sfunc_bind

	bind

******************************************************************************/

int SFUNC _sfunc_bind(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	SOCKET soc;
	struct sockaddr_in serversockaddr;
	unsigned long serveraddr;
	unsigned short Port;

	if(param == NULL){
		return -2;
	}

	//\Pbg
	soc = (SOCKET)GetValueInt(param->v);
	if((param = param->next) == NULL){
		return -2;
	}

	//AhX
	serveraddr = (unsigned long)GetValueInt(param->v);
	if((param = param->next) == NULL){
		return -2;
	}

	//|[g
	Port = (unsigned short)GetValueInt(param->v);

	serversockaddr.sin_family = AF_INET;
	serversockaddr.sin_addr.s_addr = htonl(serveraddr);
	serversockaddr.sin_port = htons(Port);
	ZeroMemory(serversockaddr.sin_zero, sizeof(serversockaddr.sin_zero));

	if(bind(soc, (struct sockaddr *)&serversockaddr, sizeof(serversockaddr)) == SOCKET_ERROR){
		ret->v->u.iValue = -1;
	}else{
		ret->v->u.iValue = 0;
	}
	ret->v->Type = TYPE_INTEGER;
	return 0;
}


/******************************************************************************

	_sfunc_listen

	listen

******************************************************************************/

int SFUNC _sfunc_listen(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	SOCKET soc;
	int backlog;

	if(param == NULL){
		return -2;
	}

	//\Pbg
	soc = (SOCKET)GetValueInt(param->v);
	if((param = param->next) == NULL){
		return -2;
	}

	//ڑ
	backlog = GetValueInt(param->v);

	if(listen(soc, backlog) == SOCKET_ERROR){
		ret->v->u.iValue = -1;
	}else{
		ret->v->u.iValue = 0;
	}
	ret->v->Type = TYPE_INTEGER;
	return 0;
}


/******************************************************************************

	_sfunc_accept

	accept

******************************************************************************/

int SFUNC _sfunc_accept(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	SOCKET soc, remote;

	if(param == NULL){
		return -2;
	}

	//\Pbg
	soc = (SOCKET)GetValueInt(param->v);

    remote = accept(soc, (struct sockaddr *)0, (int *)0);
	if(remote == INVALID_SOCKET){
		remote = -1;
	}
	ret->v->u.iValue = remote;
	ret->v->Type = TYPE_INTEGER;
	return 0;
}


/******************************************************************************

	Socket_RecvCheck

	Mobt@̃`FbN

******************************************************************************/

static int RecvCheck(SOCKET soc, int TimeOut)
{
	struct timeval waittime;
	fd_set rdps;
	int selret;

	waittime.tv_sec = TimeOut;
	waittime.tv_usec = 0;

	ZeroMemory(&rdps, sizeof(fd_set));
	FD_ZERO(&rdps);
	FD_SET(soc, &rdps);

	selret = select(FD_SETSIZE, &rdps, (fd_set *)0, (fd_set *)0, &waittime);
	if(selret == SOCKET_ERROR){
		return -1;
	}
	if(selret == 0 || FD_ISSET(soc, &rdps) == FALSE){
		return 0;
	}
	return 1;
}


/******************************************************************************

	_sfunc_select

	Mobt@̊mF

******************************************************************************/

int SFUNC _sfunc_select(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	SOCKET soc;
	int time;
	int selret;

	if(param == NULL){
		return -2;
	}

	//\Pbg
	soc = (SOCKET)GetValueInt(param->v);
	if((param = param->next) == NULL){
		return -2;
	}

	//^CAEg
	time = GetValueInt(param->v);
	while(time > 0){
		selret = RecvCheck(soc, 1);
		if(CheckEndEvent() == TRUE){
			return -1;
		}
		if(selret != 0){
			break;
		}
		time--;
	}

	ret->v->u.iValue = selret;
	ret->v->Type = TYPE_INTEGER;
	return 0;
}


/******************************************************************************

	_sfunc_recv

	M

******************************************************************************/

int SFUNC _sfunc_recv(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	SOCKET soc;
	VALUEINFO *vi;
	VALUE v;
	char *str;
	int len = BUF_SIZE;
	int retsize;
	int selret;
	int tmcnt = 0;
	int flags = 0;

	if(param == NULL){
		return -2;
	}

	//\Pbg
	soc = (SOCKET)GetValueInt(param->v);
	if((param = param->next) == NULL){
		return -2;
	}

	//ϐ
	vi = param;
	if((param = param->next) != NULL){
		//
		len = GetValueInt(param->v);
		if((param = param->next) != NULL){
			flags = GetValueInt(param->v);
		}
	}

	while(1){
		selret = RecvCheck(soc, TIMEOUT);
		if(selret == -1){
			ret->v->u.iValue = -1;
			ret->v->Type = TYPE_INTEGER;
			v.u.Value = "";
			v.Type = TYPE_STRING;
			SetValue(ei, vi->v, &v);
			return 0;
		}
		if(CheckEndEvent() == TRUE){
			return -1;
		}
		if(selret == 0){
			tmcnt++;
			if(tmcnt > TIMEOUTCNT){
				ret->v->u.iValue = -1;
				ret->v->Type = TYPE_INTEGER;
				return 0;
			}
			continue;
		}
		break;
	}

	str = mem_alloc(len + 1);
	if(str == NULL){
		tstrcpy(ErrStr, "recv: mۂɎs܂B");
		return -1;
	}
	ZeroMemory(str, len + 1);
	retsize = recv(soc, str, len, flags);
	v.u.Value = str;
	v.Type = TYPE_STRING;
	SetValue(ei, vi->v, &v);
	mem_free(&str);

	ret->v->u.iValue = retsize;
	ret->v->Type = TYPE_INTEGER;
	return 0;
}


/******************************************************************************

	_sfunc_recvhash

	M

******************************************************************************/

int SFUNC _sfunc_recvhash(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	VALUEINFO *vi;
	SOCKET soc;
	char *cbuf;
	int len = BUF_SIZE;
	int retsize;
	int selret;
	int tmcnt = 0;
	int flags = 0;

	if(param == NULL){
		return -2;
	}

	//\Pbg
	soc = (SOCKET)GetValueInt(param->v);
	if((param = param->next) == NULL){
		return -2;
	}

	//ϐ
	vi = param->v->vi;
	if((param = param->next) != NULL){
		//
		len = GetValueInt(param->v);
		if((param = param->next) != NULL){
			flags = GetValueInt(param->v);
		}
	}

	while(1){
		selret = RecvCheck(soc, TIMEOUT);
		if(selret == -1){
			ret->v->u.iValue = -1;
			ret->v->Type = TYPE_INTEGER;
			return 0;
		}
		if(CheckEndEvent() == TRUE){
			return -1;
		}
		if(selret == 0){
			tmcnt++;
			if(tmcnt > TIMEOUTCNT){
				ret->v->u.iValue = -1;
				ret->v->Type = TYPE_INTEGER;
				return 0;
			}
			continue;
		}
		break;
	}

	cbuf = mem_alloc(len);
	if(cbuf == NULL){
		tstrcpy(ErrStr, "RecvHash: mۂɎs܂B");
		return -1;
	}
	retsize = recv(soc, cbuf, len, flags);
	if(retsize > 0){
		Byte2Hash(ei, vi, cbuf, retsize);
	}
	mem_free(&cbuf);

	ret->v->u.iValue = retsize;
	ret->v->Type = TYPE_INTEGER;
	return 0;
}


/******************************************************************************

	_sfunc_send

	M

******************************************************************************/

int SFUNC _sfunc_send(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	SOCKET soc;
	char *str, *r;
	struct timeval waittime;
	fd_set rdps;
	int selret;
	int tmcnt = 0;
	int len, slen;
	int flags = 0;

	if(param == NULL){
		return -2;
	}

	//\Pbg
	soc = (SOCKET)GetValueInt(param->v);
	if((param = param->next) == NULL){
		return -2;
	}
	str = r = GetValueString(param->v);
	len = tstrlen(str);
	if((param = param->next) == NULL){
		slen = len;
	}else{
		//
		slen = GetValueInt(param->v);
		if(slen > len || slen <= 0){
			slen = len;
		}
		if((param = param->next) != NULL){
			flags = GetValueInt(param->v);
		}
	}

	waittime.tv_sec = TIMEOUT;
	waittime.tv_usec = 0;

	while(slen > 0){
		//Mobt@̋mF
		ZeroMemory(&rdps, sizeof(fd_set));
		FD_ZERO(&rdps);
		FD_SET(soc, &rdps);
		selret = select(FD_SETSIZE, (fd_set *)0, &rdps, (fd_set *)0, &waittime);
		if(selret == SOCKET_ERROR){
			mem_free(&str);
			ret->v->u.iValue = -1;
			ret->v->Type = TYPE_INTEGER;
			return 0;
		}
		if(CheckEndEvent() == TRUE){
			mem_free(&str);
			return -1;
		}
		if(selret == 0 || FD_ISSET(soc, &rdps) == FALSE){
			tmcnt++;
			if(tmcnt > TIMEOUTCNT){
				mem_free(&str);
				ret->v->u.iValue = -1;
				ret->v->Type = TYPE_INTEGER;
				return 0;
			}
			continue;
		}

		//M
		if((len = send(soc, r, slen, flags)) == -1){
			mem_free(&str);
			ret->v->u.iValue = -1;
			ret->v->Type = TYPE_INTEGER;
			return 0;
		}
		r += len;
		slen -= len;
	}
	mem_free(&str);
	return 0;
}


/******************************************************************************

	_sfunc_sendhash

	M

******************************************************************************/

int SFUNC _sfunc_sendhash(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	SOCKET soc;
	struct timeval waittime;
	fd_set rdps;
	char *cbuf;
	char *p;
	int selret;
	int tmcnt = 0;
	int len, hlen;
	int flags = 0;

	if(param == NULL){
		return -2;
	}

	//\Pbg
	soc = (SOCKET)GetValueInt(param->v);
	if((param = param->next) == NULL){
		return -2;
	}

	//ϐ
	len = Hash2Byte(param, &cbuf);
	if((param = param->next) == NULL){
		hlen = len;
	}else{
		//
		hlen = GetValueInt(param->v);
		if(hlen > len || hlen <= 0){
			hlen = len;
		}
		if((param = param->next) != NULL){
			flags = GetValueInt(param->v);
		}
	}
	p = cbuf;

	waittime.tv_sec = TIMEOUT;
	waittime.tv_usec = 0;

	while(hlen > 0){
		//Mobt@̋mF
		ZeroMemory(&rdps, sizeof(fd_set));
		FD_ZERO(&rdps);
		FD_SET(soc, &rdps);
		selret = select(FD_SETSIZE, (fd_set *)0, &rdps, (fd_set *)0, &waittime);
		if(selret == SOCKET_ERROR){
			mem_free(&cbuf);
			ret->v->u.iValue = -1;
			ret->v->Type = TYPE_INTEGER;
			return 0;
		}
		if(CheckEndEvent() == TRUE){
			return -1;
		}
		if(selret == 0 || FD_ISSET(soc, &rdps) == FALSE){
			tmcnt++;
			if(tmcnt > TIMEOUTCNT){
				ret->v->u.iValue = -1;
				ret->v->Type = TYPE_INTEGER;
				return 0;
			}
			continue;
		}

		//M
		if((len = send(soc, p, hlen, flags)) == -1){
			mem_free(&cbuf);
			ret->v->u.iValue = -1;
			ret->v->Type = TYPE_INTEGER;
			return 0;
		}
		hlen -= len;
		p += len;
	}
	mem_free(&cbuf);
	ret->v->u.iValue = 0;
	ret->v->Type = TYPE_INTEGER;
	return 0;
}
/* End of source */
