/**************************************************************************

	ns

	func_std.c

	(C) Copyright 1996-2001 By Tomoaki Nakashima. All right reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#include <windows.h>
#include <tchar.h>

#include "script.h"
#include "script_memory.h"
#include "script_string.h"


/**************************************************************************
	Define
**************************************************************************/

/**************************************************************************
	Global Variables
**************************************************************************/

/**************************************************************************
	Local Function Prototypes
**************************************************************************/


/******************************************************************************

	_sfunc_istype

	^̎擾

******************************************************************************/

int SFUNC _sfunc_istype(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	if(param == NULL){
		return -2;
	}

	ret->v->u.iValue = param->v->Type;
	ret->v->Type = TYPE_INTEGER;
	return 0;
}


/******************************************************************************

	_sfunc_int

	l^ɕϊ

******************************************************************************/

int SFUNC _sfunc_int(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	char *buf = param->v->u.Value;
	long i;

	if(param == NULL){
		return -2;
	}

	if(param->v->Type == TYPE_INTEGER){
		ret->v->u.iValue = param->v->u.iValue;
		ret->v->Type = TYPE_INTEGER;
		return 0;
	}

	if(*buf == '0' && *(buf + 1) != '\0'){
		if(*(buf + 1) == 'x' || *(buf + 1) == 'X'){
			//16i
			i = x2d(buf + 2);
		}else{
			if(*(buf + 1) == '8' || *(buf + 1) == '9'){
				i = atol(buf);
			}else{
				//8i
				i = o2d(buf + 1);
			}
		}
	}else{
		//10i
		i = atol(buf);
	}
	ret->v->u.iValue = i;
	ret->v->Type = TYPE_INTEGER;
	return 0;
}


/******************************************************************************

	_sfunc_uintstr

	l𕄍l̕ɕϊ

******************************************************************************/

int SFUNC _sfunc_uintstr(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	TCHAR tmp[BUF_SIZE];

	if(param == NULL){
		return -2;
	}

	wsprintf(tmp, TEXT("%u"), (unsigned long)GetValueInt(param->v));

#ifdef UNICODE
	ret->v->u.Value = tchar2char(tmp);
#else
	ret->v->u.Value = alloc_copy(tmp);
#endif
	ret->v->Type = TYPE_STRING;
	return 0;
}


/******************************************************************************

	_sfunc_sleep

	w莞ԑҋ@

******************************************************************************/

int SFUNC _sfunc_sleep(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	int i;

	if(param == NULL){
		return -2;
	}

	i = GetValueInt(param->v);
	for(; i > 0; i--){
		//1b҂
		Sleep(1000);
		//XNvgICxg̃`FbN
		if(CheckEndEvent() == TRUE){
			return -1;
		}
	}
	return 0;
}


/******************************************************************************

	_sfunc_wait

	w莞ԑҋ@

******************************************************************************/

int SFUNC _sfunc_wait(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	return _sfunc_sleep(ei, param, ret, ErrStr);
}


/******************************************************************************

	_sfunc_getdate

	t̎擾

******************************************************************************/

int SFUNC _sfunc_getdate(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	TCHAR *str;
	TCHAR buf[BUF_SIZE];

	if(param == NULL){
		return -2;
	}

	str = TGetValueString(param->v);
	if(*str == '\0'){
		GetDateFormat(0, 0, NULL, NULL, buf, BUF_SIZE - 1);
	}else{
		GetDateFormat(0, 0, NULL, str, buf, BUF_SIZE - 1);
	}

#ifdef UNICODE
	ret->v->u.Value = tchar2char(buf);
#else
	ret->v->u.Value = alloc_copy(buf);
#endif
	ret->v->Type = TYPE_STRING;
	mem_free(&str);
	return 0;
}


/******************************************************************************

	_sfunc_gettime

	Ԃ̎擾

******************************************************************************/

int SFUNC _sfunc_gettime(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	TCHAR *str;
	TCHAR buf[BUF_SIZE];

	if(param == NULL){
		return -2;
	}

	str = TGetValueString(param->v);
	if(*str == '\0'){
		GetTimeFormat(0, 0, NULL, NULL, buf, BUF_SIZE - 1);
	}else{
		GetTimeFormat(0, 0, NULL, str, buf, BUF_SIZE - 1);
	}
#ifdef UNICODE
	ret->v->u.Value = tchar2char(buf);
#else
	ret->v->u.Value = alloc_copy(buf);
#endif
	ret->v->Type = TYPE_STRING;
	mem_free(&str);
	return 0;
}
/* End of source */
