/**************************************************************************

	ns

	func_string.c

	(C) Copyright 1996-2001 By Tomoaki Nakashima. All right reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#include <windows.h>
#include <tchar.h>

#include "script.h"
#include "script_memory.h"
#include "script_string.h"


/**************************************************************************
	Define
**************************************************************************/

/**************************************************************************
	Global Variables
**************************************************************************/

/**************************************************************************
	Local Function Prototypes
**************************************************************************/


/******************************************************************************

	_sfunc_chr

	l𕶎R[hɕϊ

******************************************************************************/

int SFUNC _sfunc_chr(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	char tmp[2];

	if(param == NULL){
		return -2;
	}

	*tmp = (char)GetValueInt(param->v);
	*(tmp + 1) = '\0';

	ret->v->u.Value = alloc_copy(tmp);
	ret->v->Type = TYPE_STRING;
	return 0;
}


/******************************************************************************

	_sfunc_asc

	R[h𐔒lɕϊ

******************************************************************************/

int SFUNC _sfunc_asc(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	char *str;

	if(param == NULL){
		return -2;
	}

	str = GetValueString(param->v);

	ret->v->u.iValue = (long)*str;
	ret->v->Type = TYPE_INTEGER;

	mem_free(&str);
	return 0;
}


/******************************************************************************

	_sfunc_string

	w蕶wׂ

******************************************************************************/

int SFUNC _sfunc_string(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	char *str;
	char *p;
	int cnt;

	if(param == NULL){
		return -2;
	}
	cnt = GetValueInt(param->v);
	if((param = param->next) == NULL){
		return -2;
	}
	str = GetValueString(param->v);

	p = mem_alloc(sizeof(char) * (cnt + 1));
	if(p != NULL){
		memset(p, *str, sizeof(char) * cnt);
		*(p + cnt) = '\0';
	}
	ret->v->u.Value = p;
	ret->v->Type = TYPE_STRING;
	return 0;
}


/******************************************************************************

	_sfunc_trim

	^̑Ő󔒂

******************************************************************************/

int SFUNC _sfunc_trim(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	if(param == NULL){
		return -2;
	}

	if(param->v->Type == TYPE_INTEGER){
		ret->v->u.Value = i2a(param->v->u.iValue);
		ret->v->Type = TYPE_STRING;
		return 0;
	}
	ret->v->u.Value = alloc_copy(param->v->u.Value);
	str_trim(ret->v->u.Value);
	ret->v->Type = TYPE_STRING;
	return 0;
}


/******************************************************************************

	_sfunc_len

	̒擾

******************************************************************************/

int SFUNC _sfunc_len(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	char *str;

	if(param == NULL){
		return -2;
	}

	if(param->v->Type == TYPE_INTEGER){
		str = GetValueString(param->v);
	}else{
		str = param->v->u.Value;
	}

	ret->v->u.iValue = tstrlen(str);
	ret->v->Type = TYPE_INTEGER;

	if(param->v->Type == TYPE_INTEGER){
		mem_free(&str);
	}
	return 0;
}


/******************************************************************************

	_sfunc_strcmp

	̔r

******************************************************************************/

int SFUNC _sfunc_strcmp(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	char *str1, *str2;
	int len = -1;

	if(param == NULL){
		return -2;
	}

	// 1
	str1 = GetValueString(param->v);
	if((param = param->next) == NULL){
		mem_free(&str1);
		return -2;
	}
	// 2
	str2 = GetValueString(param->v);
	if((param = param->next) != NULL){
		//
		len = GetValueInt(param->v);
	}

	if(len < 0){
		ret->v->u.iValue = tstrcmp(str1, str2);
	}else{
		ret->v->u.iValue = str_cmp_n(str1, str2, len);
		if(ret->v->u.iValue < 0) ret->v->u.iValue = -1;
		else if(ret->v->u.iValue > 0) ret->v->u.iValue = 1;
	}
	ret->v->Type = TYPE_INTEGER;

	mem_free(&str1);
	mem_free(&str2);
	return 0;
}


/******************************************************************************

	_sfunc_left

	w蕶o

******************************************************************************/

int SFUNC _sfunc_left(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	char *str;
	int len;

	if(param == NULL){
		return -2;
	}

	//
	str = GetValueString(param->v);
	if((param = param->next) == NULL){
		mem_free(&str);
		return -2;
	}
	//
	len = GetValueInt(param->v);
	if(len < 0){
		mem_free(&str);
		return 0;
	}
	ret->v->u.Value = alloc_copy_n(str, len + 1);
	ret->v->Type = TYPE_STRING;
	mem_free(&str);
	return 0;
}


/******************************************************************************

	_sfunc_right

	Ew蕶o

******************************************************************************/

int SFUNC _sfunc_right(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	char *str;
	int len;

	if(param == NULL){
		return -2;
	}

	//
	str = GetValueString(param->v);
	if((param = param->next) == NULL){
		mem_free(&str);
		return -2;
	}
	//
	len = GetValueInt(param->v);
	if(len < 0){
		mem_free(&str);
		return 0;
	}

	if((int)tstrlen(str) > len){
		ret->v->u.Value = alloc_copy(str + tstrlen(str) - len);
	}else{
		ret->v->u.Value = alloc_copy(str);
	}
	ret->v->Type = TYPE_STRING;
	mem_free(&str);
	return 0;
}


/******************************************************************************

	_sfunc_mid

	wʒuw蕶o

******************************************************************************/

int SFUNC _sfunc_mid(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	char *str;
	int st, len;

	if(param == NULL){
		return -2;
	}

	//
	str = GetValueString(param->v);
	if((param = param->next) == NULL){
		mem_free(&str);
		return -2;
	}
	//ʒu
	st = GetValueInt(param->v);
	if((param = param->next) == NULL){
		len = -1;
	}else{
		//
		len = GetValueInt(param->v);
	}

	if((int)tstrlen(str) > st){
		if(len < 0){
			ret->v->u.Value = alloc_copy(str + st);
		}else{
			ret->v->u.Value = alloc_copy_n(str + st, len + 1);
		}
	}else{
		ret->v->u.Value = alloc_copy("");
	}
	ret->v->Type = TYPE_STRING;
	mem_free(&str);
	return 0;
}


/******************************************************************************

	_sfunc_instr

	wʒuw蕶o

******************************************************************************/

int SFUNC _sfunc_instr(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	char *str1;
	char *str2;
	char *p;
	int len;
	int start = 0;
	BOOL icase = FALSE;

	if(param == NULL){
		return -2;
	}

	//
	str1 = GetValueString(param->v);
	if((param = param->next) == NULL){
		mem_free(&str1);
		return -2;
	}
	str2 = GetValueString(param->v);
	if((param = param->next) != NULL){
		//Jnʒu
		start = GetValueInt(param->v);
		if((param = param->next) != NULL && GetValueInt(param->v) != 0){
			//啶
			icase = TRUE;
		}
	}
	len = tstrlen(str2);
	ret->v->u.iValue = -1;

	if((int)tstrlen(str1) > start && start >= 0){
		for(p = str1 + start; *p != '\0'; p++){
			if(icase == TRUE){
				if(str_cmp_ni(p, str2, len) == 0){
					ret->v->u.iValue = p - str1;
					break;
				}
			}else{
				if(str_cmp_n(p, str2, len) == 0){
					ret->v->u.iValue = p - str1;
					break;
				}
			}
		}
	}
	ret->v->Type = TYPE_INTEGER;
	mem_free(&str1);
	mem_free(&str2);
	return 0;
}


/******************************************************************************

	_sfunc_tolower

	pɕϊ

******************************************************************************/

int SFUNC _sfunc_tolower(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	char *p;

	if(param == NULL){
		return -2;
	}

	ret->v->u.Value = GetValueString(param->v);
	for(p = ret->v->u.Value; *p != '\0'; p++){
		*p = (*p >= 'A' && *p <= 'Z') ? (*p - 'A' + 'a') : *p;
	}
	ret->v->Type = TYPE_STRING;
	return 0;
}


/******************************************************************************

	_sfunc_toupper

	p啶ɕϊ

******************************************************************************/

int SFUNC _sfunc_toupper(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	char *p;

	if(param == NULL){
		return -2;
	}

	ret->v->u.Value = GetValueString(param->v);
	for(p = ret->v->u.Value; *p != '\0'; p++){
		*p = (*p >= 'a' && *p <= 'z') ? (*p - 'a' + 'A') : *p;
	}
	ret->v->Type = TYPE_STRING;
	return 0;
}
/* End of source */
