/**************************************************************************

	ns

	func_std.c

	(C) Copyright 1996-2001 By Tomoaki Nakashima. All right reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#include <windows.h>
#include <commctrl.h>
#include <tchar.h>

#include "wwwcdll.h"
#include "script.h"
#include "script_memory.h"
#include "script_string.h"


/**************************************************************************
	Define
**************************************************************************/

/**************************************************************************
	Global Variables
**************************************************************************/

/**************************************************************************
	Local Function Prototypes
**************************************************************************/


/******************************************************************************

	_sfunc_messagebox

	bZ[W{bNX\

******************************************************************************/

int SFUNC _sfunc_messagebox(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	struct TPITEM *tpItemInfo = (struct TPITEM *)ei->lParam;
	HWND hWnd = (HWND)tpItemInfo->Param1;
	TCHAR *title = NULL;
	TCHAR *msg;
	int style = 0;

	if(CheckEndEvent() == TRUE){
		return -1;
	}
	if(param == NULL){
		return -2;
	}

	//bZ[W
	msg = TGetValueString(param->v);
	if((param = param->next) != NULL){
		//^Cg
		title = TGetValueString(param->v);
		if((param = param->next) != NULL){
			//X^C
			style = GetValueInt(param->v);
		}
	}

	//bZ[W{bNX\
	ret->v->u.iValue = MessageBox(hWnd, msg, title, style);
	ret->v->Type = TYPE_INTEGER;

	mem_free(&msg);
	mem_free(&title);
	return 0;
}


/******************************************************************************

	_sfunc_setstatustext

	Xe[^Xo[ɕ𑗐M

******************************************************************************/

int SFUNC _sfunc_setstatustext(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	struct TPITEM *tpItemInfo = (struct TPITEM *)ei->lParam;
	HWND hWnd = (HWND)tpItemInfo->Param1;
	TCHAR *msg;

	if(CheckEndEvent() == TRUE){
		return -1;
	}
	if(param == NULL){
		return -2;
	}

	//bZ[W
	msg = TGetValueString(param->v);
	PostMessage(GetDlgItem(hWnd, WWWC_SB), SB_SETTEXT, (WPARAM)0 | 0, (LPARAM)msg);

	mem_free(&msg);
	return 0;
}


/******************************************************************************

	_sfunc_notifycheckend

	`FbNIʒm

******************************************************************************/

int SFUNC _sfunc_notifycheckend(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
	struct TPITEM *tpItemInfo = (struct TPITEM *)ei->lParam;

	if(CheckEndEvent() == TRUE){
		return -1;
	}
	if(param == NULL){
		return -2;
	}
	//`FbNIʒm
//	PostMessage((HWND)tpItemInfo->Param1, WM_CHECKEND, GetValueInt(param->v), (LPARAM)tpItemInfo);
//	PostMessage((HWND)tpItemInfo->Param1, WM_NEXTCHECK, 0, (LPARAM)tpItemInfo);

	tpItemInfo->hGetHost1 = (HANDLE)tpItemInfo;
	PostMessage((HWND)tpItemInfo->Param1, WM_WSOCK_GETHOST,
		(WPARAM)tpItemInfo->hGetHost1, (LPARAM)GetValueInt(param->v));
	return 0;
}


/******************************************************************************

	_sfunc_setiteminfo

	ACe̐ݒ

******************************************************************************/

int SFUNC _sfunc_setiteminfo(EXECINFO *ei, VALUEINFO *param, VALUEINFO *ret, char *ErrStr)
{
#define NULLCHECK_FREE(m)	((m != NULL) ? GlobalFree(m) : 0)
	struct TPITEM *tpItemInfo = (struct TPITEM *)ei->lParam;
	VALUEINFO *vi;

	if(CheckEndEvent() == TRUE){
		return -1;
	}
	for(vi = param->vi; vi != NULL; vi = vi->next){
		if(vi->Name == NULL){
			continue;
		}
		if(tstrcmp("Title", vi->Name) == 0){
			NULLCHECK_FREE(tpItemInfo->Title);
			tpItemInfo->Title = GetValueString(vi->v);
		}else if(tstrcmp("CheckURL", vi->Name) == 0){
			NULLCHECK_FREE(tpItemInfo->CheckURL);
			tpItemInfo->CheckURL = GetValueString(vi->v);
		}else if(tstrcmp("ViewURL", vi->Name) == 0){
			NULLCHECK_FREE(tpItemInfo->ViewURL);
			tpItemInfo->ViewURL = GetValueString(vi->v);
		}else if(tstrcmp("Size", vi->Name) == 0){
			NULLCHECK_FREE(tpItemInfo->Size);
			tpItemInfo->Size = GetValueString(vi->v);
		}else if(tstrcmp("Date", vi->Name) == 0){
			NULLCHECK_FREE(tpItemInfo->Date);
			tpItemInfo->Date = GetValueString(vi->v);
		}else if(tstrcmp("OldSize", vi->Name) == 0){
			NULLCHECK_FREE(tpItemInfo->OldSize);
			tpItemInfo->OldSize = GetValueString(vi->v);
		}else if(tstrcmp("OldDate", vi->Name) == 0){
			NULLCHECK_FREE(tpItemInfo->OldDate);
			tpItemInfo->OldDate = GetValueString(vi->v);
		}else if(tstrcmp("Option1", vi->Name) == 0){
			NULLCHECK_FREE(tpItemInfo->Option1);
			tpItemInfo->Option1 = GetValueString(vi->v);
		}else if(tstrcmp("Option2", vi->Name) == 0){
			NULLCHECK_FREE(tpItemInfo->Option2);
			tpItemInfo->Option2 = GetValueString(vi->v);
		}else if(tstrcmp("Comment", vi->Name) == 0){
			NULLCHECK_FREE(tpItemInfo->Comment);
			tpItemInfo->Comment = GetValueString(vi->v);
		}else if(tstrcmp("CheckDate", vi->Name) == 0){
			NULLCHECK_FREE(tpItemInfo->CheckDate);
			tpItemInfo->CheckDate = GetValueString(vi->v);
		}else if(tstrcmp("ErrStatus", vi->Name) == 0){
			NULLCHECK_FREE(tpItemInfo->ErrStatus);
			tpItemInfo->ErrStatus = GetValueString(vi->v);
		}else if(tstrcmp("DLLData1", vi->Name) == 0){
			NULLCHECK_FREE(tpItemInfo->DLLData1);
			tpItemInfo->DLLData1 = GetValueString(vi->v);
		}else if(tstrcmp("DLLData2", vi->Name) == 0){
			NULLCHECK_FREE(tpItemInfo->DLLData2);
			tpItemInfo->DLLData2 = GetValueString(vi->v);
		}else if(tstrcmp("Status", vi->Name) == 0){
			tpItemInfo->Status = GetValueInt(vi->v);
		}else if(tstrcmp("CheckSt", vi->Name) == 0){
			tpItemInfo->CheckSt = GetValueInt(vi->v);
		}
	}
	return 0;
}

/* End of source */
