/**************************************************************************

	nsc.dll

	nsc.c

	(C) Copyright 1996-2000 By Tomoaki Nakashima. All right reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/


/**************************************************************************
	Include Files
**************************************************************************/

#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE

#include "wwwcdll.h"
#include "script.h"
#include "script_string.h"
#include "script_memory.h"
#include "resource.h"


/**************************************************************************
	Define
**************************************************************************/

#define BUFSIZE					256


/**************************************************************************
	Global Variables
**************************************************************************/

SCRIPTINFO *ScriptInfo;

extern HINSTANCE ghinst;
extern char app_path[];


/**************************************************************************
	Function Prototypes
**************************************************************************/

BOOL CALLBACK OptionItemProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);


/******************************************************************************

	ItemToString

	ACe𕶎ϐɓWJ

******************************************************************************/

static VALUEINFO *ItemToString(VALUEINFO *vi, char *name, char *buf)
{
	vi = vi->next = AllocValue();
	vi->Name = alloc_copy(name);
	vi->name_hash = str2hash(name);
	vi->v->u.Value = alloc_copy(buf);
	vi->v->Type = TYPE_STRING;
	return vi;
}


/******************************************************************************

	ItemToHash

	ACenbVɓWJ

******************************************************************************/

static VALUEINFO *ItemToHash(struct TPITEM *tpItemInfo)
{
	VALUEINFO *retvi;
	VALUEINFO *vi;

	retvi = AllocValue();

	//Title
	vi = retvi->vi = AllocValue();
	vi->Name = alloc_copy("Title");
	vi->name_hash = str2hash("Title");
	vi->v->u.Value = alloc_copy(tpItemInfo->Title);
	vi->v->Type = TYPE_STRING;

	vi = ItemToString(vi, "CheckURL", tpItemInfo->CheckURL);
	vi = ItemToString(vi, "ViewURL", tpItemInfo->ViewURL);
	vi = ItemToString(vi, "Size", tpItemInfo->Size);
	vi = ItemToString(vi, "Date", tpItemInfo->Date);
	vi = ItemToString(vi, "OldSize", tpItemInfo->OldSize);
	vi = ItemToString(vi, "OldDate", tpItemInfo->OldDate);
	vi = ItemToString(vi, "Option1", tpItemInfo->Option1);
	vi = ItemToString(vi, "Option2", tpItemInfo->Option2);
	vi = ItemToString(vi, "Comment", tpItemInfo->Comment);
	vi = ItemToString(vi, "CheckDate", tpItemInfo->CheckDate);
	vi = ItemToString(vi, "ErrStatus", tpItemInfo->ErrStatus);
	vi = ItemToString(vi, "DLLData1", tpItemInfo->DLLData1);
	vi = ItemToString(vi, "DLLData2", tpItemInfo->DLLData2);

	//Status
	vi = vi->next = AllocValue();
	vi->Name = alloc_copy("Status");
	vi->name_hash = str2hash("Status");
	vi->v->u.iValue = tpItemInfo->Status;
	vi->v->Type = TYPE_INTEGER;

	//CheckSt
	vi = vi->next = AllocValue();
	vi->Name = alloc_copy("CheckSt");
	vi->name_hash = str2hash("CheckSt");
	vi->v->u.iValue = tpItemInfo->CheckSt;
	vi->v->Type = TYPE_INTEGER;

	return retvi;
}


/******************************************************************************

	NS_InitItem

	ACȅ

******************************************************************************/

__declspec(dllexport) int CALLBACK NS_InitItem(HWND hWnd,struct TPITEM *tpItemInfo)
{
	/* XV}[N(*) */
	if(tpItemInfo->Size != NULL && tpItemInfo->Size[0] != '\0' && tpItemInfo->Size[lstrlen(tpItemInfo->Size) - 1] == '*'){
		tpItemInfo->Size[lstrlen(tpItemInfo->Size) - 1] = '\0';
	}
	if(tpItemInfo->Date != NULL && tpItemInfo->Date[0] != '\0' && tpItemInfo->Date[lstrlen(tpItemInfo->Date) - 1] == '*'){
		tpItemInfo->Date[lstrlen(tpItemInfo->Date) - 1] = '\0';
	}
	return 0;
}


/******************************************************************************

	NS_Initialize

	`FbNJn̏

******************************************************************************/

__declspec(dllexport) int CALLBACK NS_Initialize(HWND hWnd,struct TPITEM *tpItemInfo)
{
	return 0;
}


/******************************************************************************

	NS_Cancel

	`FbÑLZ

******************************************************************************/

__declspec(dllexport) int CALLBACK NS_Cancel(HWND hWnd,struct TPITEM *tpItemInfo)
{
	TerminateScript();
	return 0;
}


/******************************************************************************

	NS_Timer

	^C}[ (1bԊu)

******************************************************************************/

__declspec(dllexport) int CALLBACK NS_Timer(HWND hWnd, struct TPITEM *tpItemInfo)
{
	return CHECK_SUCCEED;
}


/******************************************************************************

	NS_Start

	`FbN̊Jn

******************************************************************************/

__declspec(dllexport) int CALLBACK NS_Start(HWND hWnd, struct TPITEM *tpItemInfo)
{
	VALUEINFO *vi;

	tpItemInfo->Param1 = (long)hWnd;
	tpItemInfo->user1 = 1;

	//
	vi = ItemToHash(tpItemInfo);
	CreateScriptThread(ScriptInfo->next, NULL, "checkitem", vi, TRUE, (long)tpItemInfo);
	return CHECK_SUCCEED;
}


/******************************************************************************

	NS_Gethost

	`FbN̏I

******************************************************************************/

__declspec(dllexport) int CALLBACK NS_Gethost(HWND hWnd, WPARAM wParam, LPARAM lParam, struct TPITEM *tpItemInfo)
{
	if(CheckEndEvent() == TRUE){
		return CHECK_END;
	}
	PostMessage((HWND)tpItemInfo->Param1, WM_CHECKEND, lParam, (LPARAM)tpItemInfo);
	return CHECK_END;
}


/******************************************************************************

	NS_GetItemText

	Nbv{[hpACẽeLXg̐ݒ

******************************************************************************/

__declspec(dllexport) HANDLE CALLBACK NS_GetItemText(struct TPITEM *tpItemInfo)
{
	EXECINFO ei;
	VALUEINFO *vi, *retvi;
	HANDLE hMemText;
	char *buf = NULL;
	char *p;

	//
	vi = ItemToHash(tpItemInfo);

	//s
	ZeroMemory(&ei, sizeof(EXECINFO));
	ei.sci = ScriptInfo->next;
	ei.lParam = (long)tpItemInfo;
	retvi = ExecFunction(&ei, NULL, "getitemtext", vi, TRUE);
	if(retvi != NULL && (int)retvi != -1){
		buf = GetValueString(retvi->v);
	}
	FreeValue(retvi);
	FreeValueList(vi);
	
	if(buf == NULL || *buf == '\0'){
		mem_free(&buf);
		return NULL;
	}

	if((hMemText = GlobalAlloc(GHND,lstrlen(buf) + 1)) == NULL){
		return NULL;
	}
	if((p = GlobalLock(hMemText)) == NULL){
		GlobalFree(hMemText);
		return NULL;
	}

	lstrcpy(p, buf);
	mem_free(&buf);

	GlobalUnlock(hMemText);
	return hMemText;
}


/******************************************************************************

	NS_CreateDropItem

	ACẽhbvt@C̐ݒ

******************************************************************************/

__declspec(dllexport) BOOL CALLBACK NS_CreateDropItem(struct TPITEM *tpItemInfo, char *fPath, char *iPath, char *ret)
{
	EXECINFO ei;
	VALUEINFO *vi, *retvi;
	int rc = FALSE;

	//
	vi = ItemToHash(tpItemInfo);

	//s
	ZeroMemory(&ei, sizeof(EXECINFO));
	ei.sci = ScriptInfo->next;
	ei.lParam = (long)tpItemInfo;
	retvi = ExecFunction(&ei, NULL, "createdropitem", vi, TRUE);
	if(retvi != NULL && (int)retvi != -1){
		rc = GetValueInt(retvi->v);
	}
	FreeValue(retvi);
	FreeValueList(vi);
	return rc;
}


/******************************************************************************

	NS_ExecItem

	ACe̎s

******************************************************************************/

__declspec(dllexport) int CALLBACK NS_ExecItem(HWND hWnd, char *Action, struct TPITEM *tpItemInfo)
{
	EXECINFO ei;
	VALUEINFO *vi, *retvi;
	int rc = -1;

	tpItemInfo->Param1 = (long)hWnd;

	//
	vi = ItemToHash(tpItemInfo);
	vi->next = AllocValue();
	(vi->next)->v->u.Value = alloc_copy(Action);
	(vi->next)->v->Type = TYPE_STRING;

	//s
	ZeroMemory(&ei, sizeof(EXECINFO));
	ei.sci = ScriptInfo->next;
	ei.lParam = (long)tpItemInfo;
	retvi = ExecFunction(&ei, NULL, "execitem", vi, TRUE);
	if(retvi != NULL && (int)retvi != -1){
		rc = GetValueInt(retvi->v);
	}
	FreeValue(retvi);
	FreeValueList(vi);

	// 1 ԂƃACRB
	return rc;
}


/******************************************************************************

	NS_Property

	ACẽvpeB

******************************************************************************/

__declspec(dllexport) int CALLBACK NS_Property(HWND hWnd,struct TPITEM *tpItemInfo)
{
	if(DialogBoxParam(ghinst,
		MAKEINTRESOURCE(IDD_DIALOG_ITEM), hWnd, OptionItemProc, (LPARAM)tpItemInfo) == FALSE){
		return -1;
	}
	return 0;
}


/******************************************************************************

	NS_ProtocolProperty

	vgR̃vpeB

******************************************************************************/

__declspec(dllexport) int CALLBACK NS_ProtocolProperty(HWND hWnd)
{
	return 0;
}


/******************************************************************************

	NS_GetInfo

	vgR

******************************************************************************/

__declspec(dllexport) int CALLBACK NS_GetInfo(struct TPPROTOCOLINFO *tpInfo)
{
	EXECINFO ei;
	VALUEINFO *tmp_vi;
	VALUEINFO *vi;
	char *p;
	int i;

	//
	InitializeScript();

	//ǂݍ
	ScriptInfo = mem_alloc(sizeof(SCRIPTINFO));
	if(ScriptInfo == NULL){
		return -1;
	}
	InitializeScriptInfo(ScriptInfo, FALSE);
	ReadScriptFile(ScriptInfo, app_path, "wwwc.ns");
	ExecGlobalArea(ScriptInfo);

	//vgR̎擾
	*tpInfo->Scheme = '\0';
	*tpInfo->NewMenu = '\0';
	*tpInfo->FileType = '\0';

	ZeroMemory(&ei, sizeof(EXECINFO));
	ei.sci = ScriptInfo->next;

	vi = GetGlobalVariable(&ei, "scheme");
	if(vi != NULL){
		p = GetValueString(vi->v);
		lstrcpy(tpInfo->Scheme, p);
		mem_free(&p);
	}
	vi = GetGlobalVariable(&ei, "newmenu");
	if(vi != NULL){
		p = GetValueString(vi->v);
		lstrcpy(tpInfo->NewMenu, p);
		mem_free(&p);
	}
	vi = GetGlobalVariable(&ei, "filetype");
	if(vi != NULL){
		p = GetValueString(vi->v);
		lstrcpy(tpInfo->FileType, p);
		mem_free(&p);
	}

	//ACej[̎擾
	tmp_vi = GetGlobalVariable(&ei, "menu");
	if(tmp_vi == NULL){
		return 0;
	}

	for(vi = tmp_vi->vi, i = 0; vi != NULL; vi = vi->next, i++);
	tpInfo->tpMenu = (struct TPPROTOCOLMENU *)GlobalAlloc(GPTR, sizeof(struct TPPROTOCOLMENU) * i);
	tpInfo->tpMenuCnt = i;

	for(tmp_vi = tmp_vi->vi, i = 0; tmp_vi != NULL; tmp_vi = tmp_vi->next, i++){
		for(vi = tmp_vi->vi; vi != NULL; vi = vi->next){
			if(vi->Name == NULL){
				continue;
			}
			if(tstrcmp("Name", vi->Name) == 0){
				p = GetValueString(vi->v);
				lstrcpy(tpInfo->tpMenu[i].Name, p);
				mem_free(&p);
			}else if(tstrcmp("Action", vi->Name) == 0){
				p = GetValueString(vi->v);
				lstrcpy(tpInfo->tpMenu[i].Action, p);
				mem_free(&p);
			}else if(tstrcmp("Default", vi->Name) == 0){
				tpInfo->tpMenu[i].Default = GetValueInt(vi->v);
			}else if(tstrcmp("Flag", vi->Name) == 0){
				tpInfo->tpMenu[i].Flag = GetValueInt(vi->v);
			}
		}
	}
	return 0;
}


/******************************************************************************

	NS_EndNotify

	WWWC̏I̒ʒm

******************************************************************************/

__declspec(dllexport) int CALLBACK NS_EndNotify(void)
{
	FreeScriptInfo(ScriptInfo);
	ScriptInfo = NULL;
	EndScript();
	return 0;
}
/* End of source */
