/**************************************************************************

	ns

	script.h

	(C) Copyright 1996-2001 By Tomoaki Nakashima. All right reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

#ifndef SCRIPT_H
#define SCRIPT_H

/**************************************************************************
	Include Files
**************************************************************************/

#include "script_regex.h"


/**************************************************************************
	Define
**************************************************************************/

#define SFUNC				__stdcall
typedef int (SFUNC *LIBFUNC)();

#define TYPE_INTEGER		0
#define TYPE_STRING			1

#define BUF_SIZE			256

//#define DEBUG_SET			//͖؂ɃfobOp̕ێ
//#define STRING_TO_NFA		//͎ɑSNFAɕϊ

//G[bZ[W
#ifdef LC_JP

#define ERR_SCRIPT			"XNvg܂"
#define ERR_FUNCTION		"֐܂"
#define ERR_FUNC			"֐G["
#define ERR_ARGUMENT		"lݒ肳Ȃ܂"
#define ERR_ARGUMENTCNT		"Ȃ܂"
#define ERR_ARGFORMAT		"1Ԗڂ̈K\Ŏw肳Ă܂"
#define ERR_SENTENCE		"\G["
#define ERR_NOTDECLARE		" :ϐ`Ă܂"
#define ERR_DECLARE			" :錾dĂ܂"
#define ERR_INDEX			"CfbNXLȔ͈͂ɂ܂"
#define	ERR_BRACE			"Ή銇ʂ܂"
#define	ERR_QUART			"Ή \" ܂"
#define	ERR_IF_ELSE			"if  else ΉĂ܂"
#define ERR_DIVZERO			"0 ŏZ܂"
#define ERR_OPERATOR		"sȉZqł"
#define ERR_STROPERATOR		"ɎgȂZqł"
#define ERR_HASHOPERATOR	"AzzɎgȂZqł"
#define ERR_FILEOPEN		"t@CI[vɎs܂"
#define ERR_LIBRARY			"Cu̓ǂݍ݂Ɏs܂"
#define ERR_ALLOC			"̊mۂɎs܂"

#else

#define ERR_SCRIPT			"Script not Found"
#define ERR_FUNCTION		"Function not Found"
#define ERR_FUNC			"Function error"
#define ERR_ARGUMENT		"Argument error"
#define ERR_ARGUMENTCNT		"Too few arguments"
#define ERR_ARGFORMAT		"Argument format error"
#define ERR_SENTENCE		"Sentence error"
#define ERR_NOTDECLARE		" :Variable is not defined"
#define ERR_DECLARE			" :Declaration overlaps"
#define ERR_INDEX			"Index error"
#define	ERR_BRACE			"Parenthesis error"
#define	ERR_QUART			"Quart error"
#define	ERR_IF_ELSE			"'if' and 'else' do not correspond"
#define ERR_DIVZERO			"Divide by ZERO"
#define ERR_OPERATOR		"Illegal operator"
#define ERR_STROPERATOR		"Illegal operator to string"
#define ERR_HASHOPERATOR	"Illegal operator to hash"
#define ERR_FILEOPEN		"File open error"
#define ERR_LIBRARY			"Library load error"
#define ERR_ALLOC			"Alloc failed"

#endif


/**************************************************************************
	Struct
**************************************************************************/

//g[N
typedef struct _TOKEN {
	int Type;
	char *buf;
	struct rege_nfa *nfa;
	long i;

	//G[ʒu (link)
	char *Err;

	//֐AhX
	long FuncAddr;
	int FuncType;

	//̃g[N
	struct _TOKEN *next;
	//ubN
	struct _TOKEN *target;
	//SYM_JUMP̃N
	struct _TOKEN *link;
} TOKEN;


//l
typedef struct _VALUE {
	union {
		char *Value;
		long iValue;
	} u;
	int Type;
	//O[oϐtO
	BOOL Global;
	//{
	struct _VALUEINFO *vi;
} VALUE;


//l
typedef struct _VALUEINFO {
	//O
	char *Name;
	int name_hash;
	//l
	struct _VALUE *v;
	//NFA
	struct rege_nfa *nfa;

	//nbV
	struct _VALUEINFO *vi;
	//nbV^
	BOOL Hash;

	//Xg
	struct _VALUEINFO *next;
} VALUEINFO;


//s
typedef struct _EXECINFO {
	char *Name;
	char *Err;

	//ϐ錾tO
	BOOL decl;
	//ʒuws
	int to_tk;

	//XNvg
	struct _SCRIPTINFO *sci;
	//[Jϐ
	struct _VALUEINFO *vi;
	//e
	struct _EXECINFO *parent;

	//u
	struct _VALUEINFO *inc_vi;
	struct _VALUEINFO *dec_vi;

	long lParam;
} EXECINFO;


//֐
typedef struct _FUNCINFO {
	//֐
	char *Name;
	int name_hash;
	//͖ (link)
	struct _TOKEN *tk;

	struct _FUNCINFO *next;
} FUNCINFO;


//Cu
typedef struct _LIBRARYINFO {
	HANDLE hModul;

	struct _LIBRARYINFO *next;
} LIBRARYINFO;


//APIl
typedef struct _APIVAL {
	int type;
	long value;
	struct _APIVAL *av;

	struct _APIVAL *next;
} APIVAL;


//API
typedef struct _APIINFO {
	HANDLE hModul;

	char *func_name;
	struct _APIVAL *av;

	struct _APIINFO *next;
} APIINFO;


//XNvg
typedef struct _SCRIPTINFO {
	//t@C
	char *name;
	char *path;
	char *buf;

	//IvV
	BOOL explicit_val;

	//͖
	struct _TOKEN *tk;
	//֐Xg
	struct _FUNCINFO *fi;
	//Oϐ
	struct _VALUEINFO *vi;
	//Cu
	struct _LIBRARYINFO *lib;
	//API
	struct _APIINFO *api;

	struct _SCRIPTINFO *sci_top;
	struct _SCRIPTINFO *next;

	CRITICAL_SECTION cs;

	long param1;
	long param2;
} SCRIPTINFO;


//Xbh
typedef struct _SCRIPT_THREAD_INFO {
	struct _SCRIPTINFO *sci;
	struct _FUNCINFO *fi;

	//֐
	char *func_name;
	//
	struct _VALUEINFO *param;
	TOKEN *tk;

	BOOL no_err;

	HANDLE hth;
	unsigned int thId;

	long lParam;
} SCRIPT_THREAD_INFO;


//V{
typedef enum {
	SYM_EOF = 1,		// '\0'
	SYM_COMMENT,		// //
	SYM_LINEEND,		// ;
	SYM_CASEEND,		// :
	SYM_WORDEND,		// ,

	SYM_BOPEN,			// {
	SYM_BCLOSE,			// }

	SYM_OPEN,			// (
	SYM_CLOSE,			// )

	SYM_HASHOPEN,		// [
	SYM_HASHCLOSE,		// ]

	SYM_EQ,				// =

	SYM_CPAND,			// &&
	SYM_CPOR,			// ||

	SYM_LEFT,			// <
	SYM_LEFTEQ,			// <=

	SYM_RIGHT,			// >
	SYM_RIGHTEQ,		// >=

	SYM_EQEQ,			// ==
	SYM_REGEQ,			// =~
	SYM_NTEQ,			// !=

	SYM_AND,			// &
	SYM_OR,				// |
	SYM_XOR,			// ^

	SYM_LEFTSHIFT,		// <<
	SYM_RIGHTSHIFT,		// >>

	SYM_ADD,			// +
	SYM_SUB,			// -

	SYM_MULTI,			// *
	SYM_DIV,			// /
	SYM_MOD,			// %

	SYM_NOT,			// !
	SYM_BITNOT,			// ~
	SYM_PLUS,			// +
	SYM_MINS,			// -
	SYM_INC,			// ++
	SYM_DEC,			// --
	SYM_BINC,			// ++ (u)
	SYM_BDEC,			// -- (u)

	SYM_PREP,			// #
	SYM_POSTFIX,		// u

	SYM_CONST,			// l萔
	SYM_STRING,			// 萔
	SYM_ASSIGNSTRING,	// 
	SYM_DECLVARIABLE,	// ϐ`
	SYM_VARIABLE,		// ϐ
	SYM_HASH,			// Azz

	SYM_FUNCTION,		// Function
	SYM_ARGMATCH,		// ArgMatch
	SYM_ARGSTART,		// Argument start
	SYM_FUNC,			// Function name
	SYM_FUNCEND,		// Function end

	//\
	SYM_VAR,			// var
	SYM_IF,				// if
	SYM_ELSE,			// else
	SYM_FOR,			// for
	SYM_WHILE,			// while
	SYM_DO,				// do
	SYM_BREAK,			// break
	SYM_CONTINUE,		// continue
	SYM_SWITCH,			// switch
	SYM_CASE,			// case
	SYM_DEFAULT,		// default
	SYM_RETURN,			// return
	SYM_EXIT,			// exit

	SYM_JUMP,			// jump

	SYM_CMP,			// Compare
	SYM_CMPEND,			// Compare end
	SYM_LOOP,			// loop
	SYM_LOOPSTART,		// Loop start
	SYM_LOOPEND,		// Loop end
	SYM_DAMMY,			// Dammy
};


/**************************************************************************
	Function Prototypes
**************************************************************************/

void InitializeScript();
void EndScript();
void TerminateScript();
void ScriptWait();
void ScriptUnWait();
BOOL CheckEndEvent();
void Error(EXECINFO *ei, char *buf, char *msg, BOOL trace);

//
void FreeToken(TOKEN *tk);
void FreeValue(VALUEINFO *vi);
void FreeValueList(VALUEINFO *vi);
void FreeExecInfo(EXECINFO *ei);
void FreeFuncInfo(FUNCINFO *fi);
void FreeScriptInfo(SCRIPTINFO *sci);

//XNvg
void InitializeScriptInfo(SCRIPTINFO *sci, BOOL op_exp);

//ϐ
void GlobalWait(SCRIPTINFO *sci);
void GlobalUnWait(SCRIPTINFO *sci);

VALUEINFO *AllocValue();

VALUEINFO *GetHashValue(EXECINFO *ei, VALUEINFO *pvi, VALUE *keyv);
BOOL Byte2Hash(EXECINFO *ei, VALUEINFO *pvi, char *buf, int len);
int Hash2Byte(VALUEINFO *pvi, char **ret);

char *GetValueString(VALUE *v);
TCHAR *TGetValueString(VALUE *v);
long GetValueInt(VALUE *v);
void SetValue(EXECINFO *ei, VALUE *to_v, VALUE *from_v);

VALUEINFO *GetVariable(EXECINFO *ei, char *name);
VALUEINFO *GetLocalVariable(EXECINFO *ei, char *name);
BOOL SetLocalVariable(EXECINFO *ei, char *name, VALUE *v);
VALUEINFO *GetGlobalVariable(EXECINFO *ei, char *name);
BOOL SetGlobalVariable(EXECINFO *ei, char *rname, VALUE *v);

VALUEINFO *CopyValueList(VALUEINFO *From);
VALUEINFO *VariableFromString(EXECINFO *ei, char *param);

//s
int ExecSentense(EXECINFO *ei, TOKEN *cu_tk, VALUEINFO *retvi, VALUEINFO **retstack, int *breakcnt);
int GetExecFuncCnt();
VALUEINFO *ExecFunction(EXECINFO *ei, TOKEN *tk, char *name, VALUEINFO *param, BOOL no_err);
long CreateScriptThread(SCRIPTINFO *sci, TOKEN *tk, char *func_name, VALUEINFO *param, BOOL no_err, long lParam);
void ExecGlobalArea(SCRIPTINFO *sci);

//
TOKEN *ParseVariable(EXECINFO *ei, char *buf);
TOKEN *ParseSentence(EXECINFO *ei, char *buf, int level);

//ǂݍ
BOOL ReadScriptFile(SCRIPTINFO *sci, char *path, char *FileName);
BOOL ReadScriptFiles(SCRIPTINFO *sci, char *path, char *FileName);
char *Preprocessor(SCRIPTINFO *sci, char *path, char *p);

#ifdef NO_EXPORT
void InitFuncAddress();
LIBFUNC GetFuncAddress(char *FuncName);
#endif

#endif
/* End of source */
